/**
 * Muehle stellt grundlegende Funktionalitt einer
 * Mhle zur Verfgung:
 * - Die Lagerhaltung
 * 
 * mahlen() bleibt weiterhin abstract
 */
public abstract class Muehle extends Haus implements IMuehle {
	protected LagerQueue kornlager;
	protected LagerQueue mehllager;
	
	public Muehle(){
		kornlager = new LagerQueue();
		mehllager = new LagerQueue();
	}
	
	public Muehle(String derName){
		this();
		setName(derName);
	}
	
	public Id anliefern(Korn korn){
		Id theId = new Id();
		kornlager.push(theId);
		System.out.println(getName()+": Korn angeliefert. Folgende Id vergeben: "+theId.getId());
		return theId;
	}
	
	public abstract void mahlen() throws MahlException;
	
	public MehlSack abholen(){
		MehlSack res = (MehlSack) mehllager.pop();
		if (res != null) System.out.println(getName()+": Mehlsack mit der Id "+res.getId().getId()+" abgeholt.");
		else System.out.println(getName()+": Lager leer");
		return res;
	}
}
